org.modeshape.jcr.spi.index

## Interface IndexDefinition

- All Superinterfaces:
    Iterable<IndexColumnDefinition>
  All Known Subinterfaces:
    IndexDefinitionTemplate

      @Immutable
      public interface IndexDefinition
      extends Iterable<IndexColumnDefinition>

  An immutable description of an index definition.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `IndexDefinition.IndexKind` The kind of indexes.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getDescription()` Get the description of this index.
    `IndexDefinition.IndexKind` | `getKind()` Get the kind of index.
    `String` | `getName()` Get the name of this index.
    `Name` | `getNodeTypeName()` Get the name of the node type for which this index applies.
    `Map<Name,Property>` | `getProperties()` Get the index properties keyed by their name.
    `Property` | `getProperty(Name propertyName)` Get the index property with the given name.
    `String` | `getProviderName()` Get the name of the provider that owns this index.
    `boolean` | `hasSingleColumn()` Determine whether this index has a single column.
    `boolean` | `isEnabled()` Determine whether this index is currently enabled.

    - ### Methods inherited from interface java.lang.Iterable

      `iterator`

- - ### Method Detail

    - #### getName

          String getName()

      Get the name of this index.
      Returns:
        the name of this index; never null

    - #### getProviderName

          String getProviderName()

      Get the name of the provider that owns this index.
      Returns:
        the provider name; never null

    - #### getKind

          IndexDefinition.IndexKind getKind()

      Get the kind of index.
      Returns:
        the index kind; never null

    - #### getNodeTypeName

          Name getNodeTypeName()

      Get the name of the node type for which this index applies.
      Returns:
        the node type name; never null

    - #### getDescription

          String getDescription()

      Get the description of this index.
      Returns:
        the description; never null

    - #### isEnabled

          boolean isEnabled()

      Determine whether this index is currently enabled.
      Returns:
        true if this index is enabled and active, or false if it is not currently being used

    - #### hasSingleColumn

          boolean hasSingleColumn()

      Determine whether this index has a single column.
      Returns:
        true if this index has a single column, or false if it has more

    - #### getProperty

          Property getProperty(Name propertyName)

      Get the index property with the given name. These properties are usually non-standard.
      Parameters:
        `propertyName` - the property name; may not be null
      Returns:
        the property, or null if there is no property with that name

    - #### getProperties

          Map<Name,Property> getProperties()

      Get the index properties keyed by their name. These properties are usually non-standard.
      Returns:
        the properties; never null but possibly empty

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.